/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#if !defined(AFX_CUSTOMLIST_H__3BCE6295_516B_4715_A125_E1A03E26DF40__INCLUDED_)
#define AFX_CUSTOMLIST_H__3BCE6295_516B_4715_A125_E1A03E26DF40__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define MAXITEMSTRING	256

#define ITEM_STATE_OK 1
#define ITEM_STATE_TO_SYNC 2

#define ANIM_TIMER_OFFSET 500
#define ANIM_ICON_DELAY 250

#define LIST_COLOR_BACKGROUND RGB(255,255,255)
//#define LIST_COLOR_SELECTED_ITEM RGB(220,220,255)
#define LIST_COLOR_SELECTED_ITEM RGB(153, 209, 252) // #99d1fc
#define LIST_COLOR_TEXT RGB(0,0,0)

#define OFFSET_SYNC_STATUS_TEXT_SPH 59
#define OFFSET_SYNC_STATUS_TEXT_PPC 60

#include <afxtempl.h>
class CExtItem
{
protected:
    CString itemName;
    CString itemStatus;
    bool enabled;
    int id;
    
    
public:
    CExtItem(int _id,CString sItemName,HICON hIcon)
    {
        itemName = sItemName;
        m_hIcon = hIcon;
        itemState = ITEM_STATE_OK;
        enabled = true;
        id = _id;
        counterAnim = 0;
        bSyncing = false;
    }

    CString getName() {return itemName;}
    void setName(CString s1) {itemName = s1; }
    CString getText() {return itemStatus;}
    void setText(CString s1) {itemStatus = s1; }
    bool isEnabled() const { return enabled; }
    void setEnabled(bool val) { enabled = val; }
    int getId() const { return id; }
    void setId(int val) { id = val; }

public:
    int itemState;
    HICON	m_hIcon;

    // in which phase the anim icon is
    int counterAnim;

    // this source is currently syncing
    bool bSyncing;
};


class CCustomList : public CListCtrl
{
// Construction
public:
	CCustomList();

// Attributes
public:

// Operations
public:
    int  GetCurSelItem() const;
    BOOL SetCurSelItem(int nIndex);
    
    // sets the default icon for a source
    void resetSourceIcon(int id);

    CExtItem* getItem(int index);
protected:
    void RepaintSelectedItems();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCustomList)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL
	

// Implementation
public:
    virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
    BOOL GetItemRect(int nItem,LPRECT lpRect, UINT nCode ) const;

	virtual ~CCustomList();

	// Generated message map functions
protected:
	//{{AFX_MSG(CCustomList)
   afx_msg void OnSetFocus(CWnd* pOldWnd);
   afx_msg void OnKillFocus(CWnd* pNewWnd);
   afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
   //afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
   afx_msg LRESULT OnSetFont(WPARAM wParam, LPARAM);
   afx_msg void MeasureItem ( LPMEASUREITEMSTRUCT lpMeasureItemStruct );
   //afx_msg void OnDrawItem(  int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
   afx_msg void OnTimer( UINT_PTR nIDEvent );
   afx_msg void OnPaint( );
   afx_msg BOOL OnEraseBkgnd(CDC* pDC );


	//}}AFX_MSG
 DECLARE_MESSAGE_MAP()

private:
    void Init();

    CBrush brushHollow;
    CBitmap bmpLight;
    CBitmap bmpBlue;
    int nItemHeight, nItemWidth; // item sizes

public:
    CFont fontBold;
    void addItem(int id, CString lpszItemName,HICON hIcon); 
    void setText(int id, CString text);
    CString getText(int id);
    void setIcon(int id, HICON hIcon);
    void setItemHeight(int height) { nItemHeight = height; }
    int getItemHeight(){return nItemHeight;}
    void setItemWidth(int width)  { nItemWidth = width; }

    void startAnim(int id);
    void stopAnim(int id);

    int getState(int id);
    void setState(int id, int state);
    void setStateToAll(int state, bool onlyEnabled = false);
    void enableItem(int id, bool enable);
    bool isEnabledItem(int id);
    void InvalidatePane(int id);

    int indexToId(int index);
    int idToIndex( int id );

    bool doesIdExist(int id);

    void setIsSyncing(int id, bool value);
    bool getIsSyncing(int id);
    
    void resetSourceIcons();
   
    CArray<CExtItem *> pItemList;
    BOOL				m_bEdge;	   // edge line
    int					m_curSel;	   // current select index base on zero
    bool locked;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif 