/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "ui.h" 
#include "afxcmn.h"
#include "afxwin.h"
#include "CustomButton.h"

class CSyncSettings : public CDialog
{
    DECLARE_DYNAMIC(CSyncSettings)

public:
    CSyncSettings(CWnd* pParent = NULL);   // standard constructor
    virtual ~CSyncSettings();

// Dialog Data
    enum { IDD = IDD_UI_SYNC };

protected: 
    CButton checkMail;
    CButton checkCalendar;
    CButton checkContacts;
    CButton checkTasks;
    CButton checkBriefcase;
    CFont fontBold; 
    CCustomButton linkAdvanced;
    //CCustomButton linkMail;

    SHMENUBARINFO dlgCommandBar; 

    #if defined(WIN32_PLATFORM_PSPC) 
        CButton checkNotes;
        CCustomButton butNotes;
    #endif
        
        
    CCustomButton butMail;
    CCustomButton butCalendar;
    CCustomButton butContacts;
    CCustomButton butTasks;
    CCustomButton butBriefcase;

    CString source;
    int advanced;

    // enables/disables the right soft key 'Details' button
    //void EnableAdvancedButton(bool bEnable);

    // loads strings onto the dialog from the stringtable
    void LoadStringResources();

    // returns true if the message was processed
    bool processKeyEvents(WPARAM key);

    BOOL PreTranslateMessage(MSG* pMsg);
    virtual BOOL OnInitDialog();
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

    DECLARE_MESSAGE_MAP()
public:
   
    afx_msg void OnSetfocusSyncContacts();
    afx_msg void OnBnClickedSyncContacts();
    afx_msg void OnBnSetfocusSyncCalendar();
    afx_msg void OnSetFocus( CWnd* pOldWnd  );
    afx_msg void showAdvanced();
    afx_msg void OnBnSetfocusSyncTasks();
    afx_msg void OnBnSetfocusSyncMail();
    afx_msg void OnBnSetfocusSyncBriefcase();
    afx_msg void OnBnSetfocusScheduler();
    
    afx_msg void OnBnClickedSyncCalendar();
    afx_msg void OnBnClickedSyncTasks();
    afx_msg void OnBnClickedSyncMail();
    afx_msg void OnBnClickedSyncBriefcase();
    afx_msg void OnOK();
    afx_msg void OnClickedSyncButtonMail();
    afx_msg void OnClickedSyncButtonCalendar();
    afx_msg void OnClickedSyncButtonContacts();
    afx_msg void OnClickedSyncButtonTasks();
    afx_msg void OnClickedSyncButtonBriefcase();
    
    #if defined(WIN32_PLATFORM_PSPC)
    afx_msg void OnBnClickedSyncNotes();
        afx_msg void OnBnSetfocusSyncNotes();        
    #endif
    
    afx_msg void OnClickedSyncButtonNotes();
    afx_msg void OnBnClickedSyncLinkAdvanced();
    afx_msg void OnBnSetfocusSyncLinkAdvanced();
};
